require 'rubygems'
require 'statemachine'

class TurnstileContext
  
  def lock
    puts "lock"
  end
  
  def unlock
    puts "unlock"
  end
  
  def thanks
    puts "thanks"
  end
  
  def alarm
    puts "alarm"
  end
  
end

sm = Statemachine.build do
  trans :locked,    :coin, :unlocked, :unlock
  trans :locked,    :pass, :locked,   :alarm
  trans :unlocked,  :pass, :locked,   :lock
  trans :unlocked,  :coin, :unlocked,   :thanks 
  context TurnstileContext.new
end

sm.coin
sm.pass
sm.pass
sm.coin
sm.coin
