require 'rubygems'
require 'statemachine'


module ParserStatemachine
  
  def self.create_with(parser_context)
    
    return Statemachine.build do
      trans :code, :other, :code, :print
      trans :code, :pigpen, :code, :print
      trans :code, :endl, :new_line, :print
      trans :new_line, :other, :code, :print
      trans :new_line, :pigpen, :in_comment
      trans :new_line, :endl, :new_line, :print
      trans :in_comment, :other, :in_comment
      trans :in_comment, :pigpen, :in_comment
      trans :in_comment, :endl, :new_line
      startstate :new_line
      context parser_context
    end
    
  end
  
end